/*
 [The "BSD licence"]
 Copyright (c) 2006 Loring Craymer
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.
 3. The name of the author may not be used to endorse or promote products
    derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/





header {
}


@{
	Payload PayloadToken {
		Integer line;
		Integer charPositionInLine;
		Integer channel;
		Integer index;
		Integer start;
		Integer stop;
	}

	PayloadToken Payload1 {
		Integer foo;
	}

	PayloadToken Payload2 {
		Integer bar;
	}
}


options {
	package = "examples.generic.treetest.*";
}

tree grammar TestParserTree;
@{
	Payload a;
	Payload b;
	PayloadToken c;
	PayloadToken d;
	PayloadToken e;
	PayloadToken f;
	PayloadToken g;
	PayloadToken h;
	PayloadToken i;
	PayloadToken j;
	PayloadToken k;
	PayloadToken v;
	Carrier testCarrier;
}

options {
	tokenVocab = "TestParser";
}


topLevel
	:
	(
		topAlt
	)+
	;

topAlt
	:
	insert
	|
		insertTree
	|
		insertNode
	|
		insertRootNode
	|
		insertTrees
	|
		retTest
	|
		cutTest
	|
		treeGen
	|	ebnfTest
	|	groupTest
	|	constructionPredTest
	|	tableTest
	|	reverseQTest
	|	queueItemTest
	;

insert
	:
	C
	D
	A
	B
	E
	;

insertTree
	:
	H
	I
	#( 
		F
		G
	)
	;

insertNode
	:
	J
	K
	L
	M
	N
	;

insertRootNode
	:
	#( 
		Q
		O
		P
		R
		S
	)
	;

insertTrees
	:
	Fa
	#( 
		@a = Aa  @a
		#( 
			@b = Ba  @b
			Ca
			#( 
				@d = Da   @d
				Ea
				Fa
			)
			Ga
			#( 
				@h = Ha   @h
				Ia
				Ja
			)
		)
	)
	Ka
	;

retTest
	:
	V
	;

cutTest
	:
	Z
	A
	;

treeGen
	:
	#( 
		Cb
		a_1
		b_1
		e_1
		f_1
	)
	|
		#( 
			Db
			a_1
			b_1
			e_1
			f_1
		)
	;

a_1
	:
	#( 
		Bb
		Ab
		Eb
	)
	;

b_1
	:
	#( 
		Ib
		#( 
			Gb
			Fb
			Hb
		)
		Jb
	)
	;

e_1
	:
	#( 
		Ob
		#( 
			Nb
			#( 
				Kb
				Lb
				Mb
			)
		)
	)
	;

f_1
	:
	Pb
	Qb
	Rb
	;

/*
notTest
	:
	~( A | B )
	D
	~C
	;
*/

ebnfTest
	:
	#(	Bc
		Ac
		Gc
		Dc Ec Fc
		Hc
	)
	;

groupTest
	:
	Ic
	;

/*
predTest
	:
	Mc | Nc
	;
*/

constructionPredTest
	:
	Qc
	|
		Rc
	|
		Sc
	;

tableTest
	:
	C D E B F
	;

reverseQTest
	:
	J I H G
	;

queueItemTest
	:
	K N L M
	;

